<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php
/****************************************************************************
* Project:       PHP Remote Studio Applet
* Invoking a Remote Task in Omnis Studio (Version > 4.1) with a PHP Script
*****************************************************************************
* File:          rsa_demo.php
* First created: 2006-06-07
* Author:        NN
* Last modified: 2006-06-12
* Modified by:   Michael Hufschmidt
* Copyright (C): Raining Data 2004
*****************************************************************************
* Content / Description / Requirements / Usage:
*
* Example code to demonstrate the Remote Studio Applet with PHP4
****************************************************************************/
  set_include_path("." . PATH_SEPARATOR . get_include_path());
  require_once ("RSA_App.php");
  $inifilename = "rsa_demo.ini";
  ini_set('error_reporting', E_ALL & ~E_NOTICE);
?>
<html>
<head>
<title>Remote Studio Applet Demo</title>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<style type="text/css">
<!--
body, h1, h2, h3, h4, h5, p, ul, ol, li, table, th, td, thead, tbody, tfoot {
  color: #000000;
  background-color: #FFFFFF;
  font-family: Arial, Helvetica, Verdana, sans-serif;
  font-size: 12pt;
  text-align: left;
  }
td {padding: 10px;
  }
h1, h2, h3, h4, h5 {
  font-weight: bold;
  color: #A02020;
  }
h1 {font-size: 24pt;
  }
h3 {font-size: 16pt;
  }
-->
</style>
</head>
<body>
<h1>Demo for Omnis Studio / Remote Studio Applet</h1>
<p>Remote Studio is an applet, which provides an equivalent of remote procedure calls to an Omnis server in order to provide functionality. The applet may reside either on the client or the server and can be utilized from many languages. For example, you could invoke it on your server from PERL or PHP, or invoke it on your client from Java, VBScript, Delphi or .NET (C#, C or Visual Basic).</p>
<p>This is a demo based on PHP4. It instanciates a remote task within Omnis Studio, calls a method in the remote task, optionally provides it with parameters from PHP (taken from a HTML form) and returns the result from Omnis to PHP.</p>
<hr noshade size="2">
<h3>Content of the .ini - File:</h3>
<?php
  if (file_exists($inifilename)) {
    echo "<pre>\r\n";
    $fi = fopen($inifilename, "r");
    while (!feof($fi)) {
      $text = htmlspecialchars(fgets($fi, 4096));
      echo "$text";
    }
    fclose($fi);
    echo "\n</pre>\r\n";
  } else {
    echo "<p>Could not open the file $inifilename</p>\r\n";
  }
?>
<hr noshade size="2">
<h3>Select Test Method to call in Omnis</h3>
<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="Post" target="_self">
<table >
  <tr>
    <th>Omnis Method</th>
    <th>Expected Result</th>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="1" checked> Method returning a String</td>
    <td>&quot;this comes from Omnis&quot;</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="2"> Method returning a Longint</td>
    <td>-305419896</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="3"> Method returning a Float</td>
    <td>1234.5678</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="4"> Method returning a Date</td>
    <td>31 Mar 1970</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="5"> Method returning a Time</td>
    <td>12:34:56</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="6"> Method returning a DateTime</td>
    <td>31 MAR 70  12:34:56.00</td>
  </tr>
  <tr>
    <td><input type="Radio" name="test_no" value="7"> Method returning a List</td>
    <td>3 rows with 2 columns each</td>
  </tr>
  <tr>
    <td colspan="2"><hr noshade size="1"></td>
  </tr>
  <tr>
    <td><input type="Checkbox" name="with_params" checked> send Parameters to Omnis</td>
    <td>
      Param1 = <input type="Text" name="param1" value="The Hitchhiker's Guide to the Galaxy" size="40" maxlength="200"><br>
      Param2 = <input type="Text" name="param2" value="42" size="40" maxlength="200">
    </td>
  </tr>
<!--  This does not work properly
  <tr>
    <td colspan="2"><input type="Checkbox" name="close_task" checked>close Remote Task after calling Omnis</td>
  </tr>
-->
  <tr>
    <td colspan="2"><hr noshade size="1"></td>
  </tr>
  <tr>
    <td colspan="2"><input type="Submit" name="omnis" value="Call Omnis Method"></td>
  </tr>
  </table>
</form>
<hr noshade size="2">
<h3>Return value from Omnis</h3>

<?php
  $param_count = extract($_POST);           // make cgi-params local
  if (isset($omnis)) {
    switch ($test_no) {
      case 1:
        $method = "rtnVarString";
        break;
      case 2:
        $method = "rtnVarLongint";
        break;
      case 3:
        $method = "rtnVarFloat";
        break;
      case 4:
        $method = "rtnVarDate";
        break;
      case 5:
        $method = "rtnVarTime";
        break;
      case 6:
        $method = "rtnVarDateTime";
        break;
      case 7:
        $method = "rtnVarList";
        break;
    } // end switch
    $info = "Result from calling the Omnis Method \"$method\"";
    if (isset($with_params)) {
      $info .= " with parameters";
    } // end $with_params
    echo "<p>$info:</p>\r\n";
    echo "<pre>\n";
    // create an object
    $rsa_app = new RSA_App;
    $rsa_app->loadParams('rsa_demo.ini');
    // echo "Library = $rsa_app->mOmnisLibrary\r\n";
    // echo "Class   = $rsa_app->mOmnisClass\r\n";

    if ($rsa_app->open()) {
      echo "Port opened\r\n";
      if (isset($close_task)) {
        // add some code here
      } else {
        // add some code here
      } // end $close_task
      if (isset($with_params)) {
        $params[0] = new RSA_Var;
        $params[0]->setCString($param1);
        $params[1] = new RSA_Var;
        $params[1]->setCString($param2);
        $result = $rsa_app->execute($method, $params);
      } else {
        $result = $rsa_app->executeNoParams($method);
      } // end $with_params
      if ($test_no == 7) {
        $lst = $result->getList();
        echo "</pre>\r\n";
        echo "<table style=\"border: 1px; border-style: solid; \">\r\n";
        for ($r = 1; $r <= $lst->rowCount(); $r ++) {
          echo "  <tr>\r\n";
          echo "    <td>Row $r =</td>\r\n";
          for ($c = 1; $c <= $lst->colCount(); $c ++) {
            $var = $lst->getElement($r, $c);
            $txt = $var->getCString();
            echo "    <td style=\"border: 1px; border-style: solid; \">$txt</td>\r\n";
          }
          echo "  </tr>\r\n";
        }
        echo "</table>\r\n";
        echo "<pre>\r\n";
      } else {
        echo $result->getCString() . "\n";
      }
      $rsa_app->close();
      echo "Port closed\r\n";
    } // end $rsa_app->open()

    if ($rsa_app->getErrorID()) {
      echo "Error ID:      " . $rsa_app->getErrorID() . "\r\n";
      echo "Error Message: " . $rsa_app->getErrorText() . "\r\n";
    }
    echo "</pre>\r\n";
  }  // end isset($omnis)
?>
<hr noshade size="2">
<p>&nbsp;</p>
</body>
</html>